% CRUNCH.M does one time crunching out of search, impresp, 
% and vardecmp.  It is called by DRAWS.M

SPHERE_SAMPLING = 1; % = 1: truly impose flat prior on
                     % surface of the ball. 
                     % = 0: imposes "flat prior" on impulse
                     %   vector ("egg").  Advantage: sign
                     %   restrictions at zero can directly 
                     %   be imposed.
                     % SPHERE_SAMPLING = 1 requires approx. twice
                     % as many draws for each sign restriction
                     % except for the first one in NEG_RESP,
                     % which is obtained by flipping the signs
                     % of a randomly generated impulse vector.
N_SAMPLE = 100;
HOR =  24;

POS_RESP = [ 6 ];         % indices of variables which should 
                          % show a positive response;
POS_HORI = [ 6 ];         % horizon, for how long the response should be 
                          % positive.  NEEDS TO BE OF SAME LENGTH AS POS_RESP!
POS_WEIGHT = 0;           % set = 0, if you don't want to constraint FFR, e.g.
                          % set = 1 otherwise.
NEG_RESP = [2,3,5];       % indices of variables which should 
                          % show a negative response;
NEG_HORI = [HOR,HOR,HOR]; % horizon, for how long the response should be
                          % negative.  NEEDS TO BE OF SAME LENGTH AS NEG_RESP!

RE_SEARCH = 2; % How often should search be started from a new random vector at each iteration.
j_minsample = 3;
FRST_IMPREST = 2; % set = 1, if you want real GDP restricted.
                  % set = 2, if you don't
DO_BENCHMARK = 1; % so far, this is the only option.
DO_SAMPLE = 1; % so far, this is the only option
CRI_MAX = 0.00; % upper tolerable limit on cri, which measures
                % the violation of impulse reponses of sign criteria.
VAR_POINT = 96;

CRUNCH_HORIZON = HORIZON;
VAR_POINT = min(VAR_POINT,HORIZON);


if DO_BENCHMARK,  
   prepare;
   j_sample = 0;
   aa_opt = zeros(nvar,1);
   while j_sample < N_SAMPLE,
      if SPHERE_SAMPLING,
         sphere = randn(nvar,1);
         sphere = sphere/sqrt(sphere'*sphere);
         aa = sig_sqrt * sphere;
         if aa(NEG_RESP(2)) > 0,
            sphere = - sphere;
            aa = - aa;
         end;
      else
         aa_rand = randn(nvar,1);
         aa_rand(POS_RESP) = abs(aa_rand(POS_RESP));
         aa_rand(NEG_RESP) = - abs(aa_rand(NEG_RESP));
         sphere = sig_sqrt \ aa_rand;
         sphere = sphere/sqrt(sphere'*sphere);
         aa = sig_sqrt * sphere;
      end;
      ir_alpha = store_imp*kron(sphere,eye(nvar));
      % The following two lines are FALSE!!
      % sphere = sphere';
      % fr_alpha = (sphere.^2)*store_frac;
      fracvar = [];
      for j = 1 : nvar,
         fr_alpha = 100 * ir_alpha(1:HORI_VAR,j).*ir_alpha(1:HORI_VAR,j)./totvar(:,j);
         fracvar = [ fracvar, fr_alpha ];
      end;
      cri = 0;
      for j = 1 : max(size(POS_RESP)),
         ir_test = max(- ir_alpha(1:POS_HORI(j),POS_RESP(j)),0);
         cri = cri + POS_WEIGHT*sum(ir_test.^2);
      end;
      for j = 1 : max(size(NEG_RESP)),
         ir_test = max( ir_alpha(1:NEG_HORI(j),NEG_RESP(j)),0);
         cri = cri + sum(ir_test.^2);
      end;
      if cri <= CRI_MAX,
         % Let's store this draw:
         tot_draws = tot_draws + 1;
         ir = ir_alpha;
         counterf;
         mon_agg_draws = [mon_agg_draws, mon_agg ];
         for j = 1 : min(nvar,NVAR_MAX),
            if j == 1,
               ir1 = [ ir1, ir(:,1) ];
               fv1 = [ fv1, fracvar(:,1) ];
               sernew1 = [sernew1, sernew(PIECE,1) ];
            elseif j == 2,
               ir2 = [ ir2, ir(:,2) ];
               fv2 = [ fv2, fracvar(:,2) ];
               sernew2 = [sernew2, sernew(PIECE,2) ];
            elseif j == 3,
               ir3 = [ ir3, ir(:,3) ];
               fv3 = [ fv3, fracvar(:,3) ];
               sernew3 = [sernew3, sernew(PIECE,3) ];
            elseif j == 4,
               ir4 = [ ir4, ir(:,4) ];
               fv4 = [ fv4, fracvar(:,4) ];
               sernew4 = [sernew4, sernew(PIECE,4) ];
            elseif j == 5,
               ir5 = [ ir5, ir(:,5) ];
               fv5 = [ fv5, fracvar(:,5) ];
               sernew5 = [sernew5, sernew(PIECE,5) ];
            elseif j == 6,
               ir6 = [ ir6, ir(:,6) ];
               fv6 = [ fv6, fracvar(:,6) ];
               sernew6 = [sernew6, sernew(PIECE,6) ];
            else
            end;
         end;
      end;
      j_sample = j_sample + 1;
   end;
else
   disp('*** CRUNCH.M: SORRY - THE OPTION DO_BENCHMARK = 0 IS NOT AVAILABLE!!!  EXPECT CRASH');
end;
% HORIZON = CRUNCH_HORIZON; % To get the full impulse response
% vardecmp;
% impresp;  % Needs to be used last to keep the impulse response for aa!!!
