% Impulse responses:
% Must have estimated VAR
% Need an impulse vector aa, i.e. a
% vector which is a column of some matrix A
% with the property that A A' = Sigma, where Sigma is the variance-
% covariance matrix of the one-step ahead prediction error.
% We also calculate the variances for the k-step ahead prediction errors
% attributable to a column impulse vector aa
% This is easy to do: just sum the square of the impulse responses to aa!
% Note that we are throwing away the information about the covariances
% of the k-step ahead prediction errors, since that information is rarely looked at.
% To find the total variance of the k-step ahead prediction error, repeat this
% procedure for all columns of some matrix A with A A' = Sigma, and sum.


% HORIZON = 60;
global ir LEADTRENDS aa nlags nvar varvec bb scale_fct HORIZON
leadvec = zeros(1,LEADTRENDS);
ss = [ aa' ];
for j = 1 : (nlags-1),
   ss = [ss , 0*aa' ];
end;
ir = [  aa' ];
for j = 1 : HORIZON,
   ssnew = [ leadvec, ss ] * bb;
   ss = [  ssnew, ss(1,1:(nlags-1)*nvar) ];
   ir = [ ir
          ssnew ];
end;
ir = ir*diag(scale_fct);
varvec = ir.^2;