% Do BVAR
global ir LEADTRENDS aa nlags nvar varvec bb SCALE

nlags = 12;
LEADTRENDS = 0;
DO_OLSE = 0;
PRIOR_CHOICE = 1;

[tt,nvar] = size(series);
cap_T = tt - nlags; % subtracting out initial observations

yy = series(nlags+1:tt,:);
xx = [];
for j = 1 : LEADTRENDS,
  xx = [ xx, ((1:cap_T)').^(j-1) ];
end;
for j = 1 : nlags,
  xx = [xx, series(nlags+1-j:tt-j,:)];
end;
b_olse = (xx'*xx) \ (xx'*yy);
sig_olse = (yy - xx*b_olse)'*(yy - xx*b_olse)/cap_T;

if DO_OLSE,  
   bb = b_olse;
   sig = sig_olse;
else % Bayesian method:

   % Prior:
   
   if PRIOR_CHOICE == 1,
      % Random walk prior.  Notice: it only matters if N0 is different from zero.     
      nu_0 = 0;
      N_0 = 0*xx'*xx;
      B_0 = [ zeros(LEADTRENDS,nvar)
              eye(nvar)
              zeros((nlags-1)*nvar,nvar) ];
      S_0 = cov(diff(series));
   else
      disp('VAR.M: THERE IS NOTHING ELSE! CHANGE PRIOR_CHOICE IN MY CODE!');
   end;
   
   % The parameters of the posterior:

   nu_t = cap_T + nu_0;
   N_t = N_0 + xx'*xx;
   N_t_inv = inv(N_t);
   B_t = N_t_inv * ( N_0 * B_0 + xx'*xx*b_olse);
   S_t = (nu_0/nu_t) * S_0 + (cap_T/nu_t) * sig_olse + ...
         (1.0/nu_t)*(b_olse - B_0)'*N_0*N_t_inv*xx'*xx*(b_olse - B_0);

   % For calculations: use the "means":

   bb = B_t;
   sig = S_t;
end;

% For the preparation to use "crit.m":
[eigvec,eigval] = eig(sig);
eigsqrt = sqrt(diag(eigval));
global eigvec eigsqrt 
