% vardecmp does a variance decomposition either for a given impulse vector aa
% or a matrix AA with the property that AA * AA' = sig.

DECOMP_MODE = 0; % 0: do for aa, 
                 % 1: do for AA, 
                 % 2: do for Cholesky Decomp.
% HORI_VAR = 61; % NEEDS TO BE EQUAL OR LESS THAN HORIZON + 1 IN IMPRESP!
HORI_VAR = HORIZON;

DO_VAR_LIST = 0;

if DECOMP_MODE == 0,
   aa_store = aa;
end;

if DECOMP_MODE == 0,
   impresp;
   HORI_VAR = min(HORI_VAR,HORIZON);
   storvar = varvec(1:HORI_VAR,:);
   n_aa = 1;
else
   storvar = [];
   n_aa = nvar;
end;

if (DECOMP_MODE == 0) | (DECOMP_MODE == 2)
   AAA = chol(sig);
   AAA = AAA';
else
   AAA = AA;
end;


totvar = zeros(HORI_VAR,nvar);
for j = 1 : nvar,
   aa = AAA(:,j);
   impresp;
   HORI_VAR = min(HORI_VAR,HORIZON);
   totvar = totvar + varvec(1:HORI_VAR,:);
   if (DECOMP_MODE == 1) | (DECOMP_MODE == 2),
      storvar = [storvar, varvec(1:HORI_VAR,:) ];
   end;
end;
if DECOMP_MODE == 0,
   aa = aa_store;
end;

fracvar = [];
for j = 1 : n_aa,
   fracvar = [ fracvar, 100*storvar(:,(j-1)*nvar+1:j*nvar)./totvar ]; 
end;
if DO_VAR_LIST,
   for j = 1 : n_aa,
      disp(sprintf('Fraction of variances explained by shock # %5.0f in Percent:',j'));
      disp([(0:(HORI_VAR-1))',fracvar(:,(j-1)*nvar+1:j*nvar)]);
      disp('Hit any key when ready...');
      pause;
   end;
end;

