% VARPLOT.M plots the fraction of explained variance.  It is assumed that VARDECMP.M has
% been run before.
DO_VAR_GRAPHS = 1;
DO_EPS = 0;
HORI_VARPLOT = 25;
LOC = .65; % choose a number between 0 and 1.

piece = 1 : min(HORI_VARPLOT,HORI_VAR);
if DO_VAR_GRAPHS,
   for j = 1 : n_aa,
      plot( (piece - 1)/12,fracvar(piece,(j-1)*nvar+1:j*nvar) );
      title(sprintf('Fraction of variances explained by shock # %5.0f in Percent:',j'));
      xlabel('Years');
      ylabel('Percent');
      for i = 1 : nvar,
         text((max(piece)*LOC-1)/12,fracvar(max(piece)*LOC,(j-1)*nvar+i),names(i,:));
      end;
      disp('Hit any key when ready...');
      if DO_EPS,
         print -deps vf.eps
      else
         pause;
      end;
   end;
end;




